/*
 * Licensed to Open Source Radio Access Network(OS-RAN) Alliance and OAI
 * Software Alliance under one or more contributor license agreements. The
 * initial OpenXG series projects are derided from OAI projects, the files from
 * OAI projects are all in compliance with OAI Public License, Version 1.1.
 * codes and files developed from OpenXG projects and from OS-RAN Alliance
 * are all under OS-RAN licenses; you may not use this file except in compliance
 * with the license.  You may get a copy of the license at:
 *	http://www.openxg.org.cn/?falu_69.html
 * For more information about OpenXG, please contact:
 * contact@openxg.org.cn
 */

/*
 * IndividualPDUSessionHSMFApiImpl.h
 *
 *
 */

#ifndef INDIVIDUAL_PDU_SESSION_HSMF_API_IMPL_H_
#define INDIVIDUAL_PDU_SESSION_HSMF_API_IMPL_H_

#include <pistache/endpoint.h>
#include <pistache/http.h>
#include <pistache/router.h>
#include <memory>

#include <IndividualPDUSessionHSMFApi.h>

#include <pistache/optional.h>

#include "HsmfUpdateData.h"
#include "HsmfUpdateError.h"
#include "HsmfUpdatedData.h"
#include "ProblemDetails.h"
#include "ReleaseData.h"
#include <string>
#include "smf_app.hpp"

namespace oai {
namespace smf_server {
namespace api {

using namespace oai::smf_server::model;

class IndividualPDUSessionHSMFApiImpl
    : public oai::smf_server::api::IndividualPDUSessionHSMFApi {
 public:
  IndividualPDUSessionHSMFApiImpl(
      std::shared_ptr<Pistache::Rest::Router>, smf::smf_app* smf_app_inst,
      std::string address);
  ~IndividualPDUSessionHSMFApiImpl() {}

  void release_pdu_session(
      const std::string& pduSessionRef, const ReleaseData& releaseData,
      Pistache::Http::ResponseWriter& response);
  void update_pdu_session(
      const std::string& pduSessionRef, const HsmfUpdateData& hsmfUpdateData,
      Pistache::Http::ResponseWriter& response);

 private:
  smf::smf_app* m_smf_app;
  std::string m_address;
};

}  // namespace api
}  // namespace smf_server
}  // namespace oai

#endif
