/*
 * Licensed to Open Source Radio Access Network(OS-RAN) Alliance and OAI
 * Software Alliance under one or more contributor license agreements. The
 * initial OpenXG series projects are derided from OAI projects, the files from
 * OAI projects are all in compliance with OAI Public License, Version 1.1.
 * codes and files developed from OpenXG projects and from OS-RAN Alliance
 * are all under OS-RAN licenses; you may not use this file except in compliance
 * with the license.  You may get a copy of the license at:
 *	http://www.openxg.org.cn/?falu_69.html
 * For more information about OpenXG, please contact:
 * contact@openxg.org.cn
 */

#ifndef ALLOWED_PDU_SESSION_STATUS_H_
#define ALLOWED_PDU_SESSION_STATUS_H_

#include <stdint.h>
#include "bstrlib.h"

#define ALLOWED_PDU_SESSION_STATUS_MINIMUM_LENGTH 4
#define ALLOWED_PDU_SESSION_STATUS_MAXIMUM_LENGTH 34

typedef uint8_t AllowedPDUSessionStatus;

int encode_allowed_pdu_session_status(
    AllowedPDUSessionStatus allowedpdusessionstatus, uint8_t iei,
    uint8_t* buffer, uint32_t len);
int decode_allowed_pdu_session_status(
    AllowedPDUSessionStatus* allowedpdusessionstatus, uint8_t iei,
    uint8_t* buffer, uint32_t len);

#endif
