/*
 * Licensed to Open Source Radio Access Network(OS-RAN) Alliance and OAI
 * Software Alliance under one or more contributor license agreements. The
 * initial OpenXG series projects are derided from OAI projects, the files from
 * OAI projects are all in compliance with OAI Public License, Version 1.1.
 * codes and files developed from OpenXG projects and from OS-RAN Alliance
 * are all under OS-RAN licenses; you may not use this file except in compliance
 * with the license.  You may get a copy of the license at:
 *	http://www.openxg.org.cn/?falu_69.html
 * For more information about OpenXG, please contact:
 * contact@openxg.org.cn
 */

#ifndef EXTENDED_PROTOCOL_DISCRIMINATOR_H_
#define EXTENDED_PROTOCOL_DISCRIMINATOR_H_

#include <stdint.h>
#include "bstrlib.h"

#define EXTENDED_PROTOCOL_DISCRIMINATOR_MINIMUM_LENGTH 1
#define EXTENDED_PROTOCOL_DISCRIMINATOR_MAXIMUM_LENGTH 1

typedef uint8_t ExtendedProtocolDiscriminator;

int encode_extended_protocol_discriminator(
    ExtendedProtocolDiscriminator extendedprotocoldiscriminator, uint8_t iei,
    uint8_t* buffer, uint32_t len);
int decode_extended_protocol_discriminator(
    ExtendedProtocolDiscriminator* extendedprotocoldiscriminator, uint8_t iei,
    uint8_t* buffer, uint32_t len);

#endif
