/*
 * Licensed to Open Source Radio Access Network(OS-RAN) Alliance and OAI
 * Software Alliance under one or more contributor license agreements. The
 * initial OpenXG series projects are derided from OAI projects, the files from
 * OAI projects are all in compliance with OAI Public License, Version 1.1.
 * codes and files developed from OpenXG projects and from OS-RAN Alliance
 * are all under OS-RAN licenses; you may not use this file except in compliance
 * with the license.  You may get a copy of the license at:
 *	http://www.openxg.org.cn/?falu_69.html
 * For more information about OpenXG, please contact:
 * contact@openxg.org.cn
 */

#include <stdint.h>
#include "bstrlib.h"
#include <stdbool.h>

#define UE_STATUS_MINIMUM_LENGTH 3
#define UE_STATUS_MAXIMUM_LENGTH 3

#define UE_NOT_IN_EMM_REGISTERED 0
#define UE_IN_EMM_REGISTERED 1
#define UE_NOT_IN_5GMM_REGISTERED 0
#define UE_IN_5GMM_REGISTERED 1

typedef struct {
  bool n1_mode_reg;
  bool s1_mode_reg;
} UEStatus;

int encode_ue_status(
    UEStatus uestatus, uint8_t iei, uint8_t* buffer, uint32_t len);
int decode_ue_status(
    UEStatus* uestatus, uint8_t iei, uint8_t* buffer, uint32_t len);
