/*
 * Licensed to Open Source Radio Access Network(OS-RAN) Alliance and OAI
 * Software Alliance under one or more contributor license agreements. The
 * initial OpenXG series projects are derided from OAI projects, the files from
 * OAI projects are all in compliance with OAI Public License, Version 1.1.
 * codes and files developed from OpenXG projects and from OS-RAN Alliance
 * are all under OS-RAN licenses; you may not use this file except in compliance
 * with the license.  You may get a copy of the license at:
 *	http://www.openxg.org.cn/?falu_69.html
 * For more information about OpenXG, please contact:
 * contact@openxg.org.cn
 */

#ifndef __5GSMCAUSE_H_
#define __5GSMCAUSE_H_

#include <stdint.h>
#include "bstrlib.h"

#define _5GSM_CAUSE_MINIMUM_LENGTH 2
#define _5GSM_CAUSE_MAXIMUM_LENGTH 2

#define _5GSM_CAUSE_MINIMUM_LENGTH_TV 2
#define _5GSM_CAUSE_MAXIMUM_LENGTH_TV 2
#define _5GSM_CAUSE_MINIMUM_LENGTH_V 1
#define _5GSM_CAUSE_MAXIMUM_LENGTH_V 1

typedef uint8_t _5GSMCause;

int encode__5gsm_cause(
    _5GSMCause _5gsmcause, uint8_t iei, uint8_t* buffer, uint32_t len);
int decode__5gsm_cause(
    _5GSMCause* _5gsmcause, uint8_t iei, uint8_t* buffer, uint32_t len);

#endif
